//*********************************************************
//        Joinmax Digital RTOS Module library 1.0
//*********************************************************
// File                 : jmdos.h 
// Version              : V0.3
// Compiler             : GCCARM
// Target               : E2RCU
// Author               : CZQ
// Date                 : 2015/09/08
// Brief                : FreeRTOS for E2RCU
//*********************************************************
#ifndef _JMDOS_H_
#define _JMDOS_H_

#include "FreeRTOSConfig.h"
#include "FreeRTOS.h"
#include "task.h"
#include "queue.h"
#include "list.h"
#include "portable.h"
#include "semphr.h"
//#include "HardwareInfo.c"

//Ϊûбû
int main(void);
void task1(void);
void task2(void);
void task3(void);
void task4(void);
void task5(void);
void task6(void);
void task7(void);
void task8(void);
//Ϊϵͳĺбûִ
void task_main_entry(void);
void task1_entry(void);
void task2_entry(void);
void task3_entry(void);
void task4_entry(void);
void task5_entry(void);
void task6_entry(void);
void task7_entry(void);
void task8_entry(void);
u16 OS_TaskCreate(u8 tasknum);	//񴴽,һԲ
u16 OS_TaskDelete(u8 tasknum);	//ɾ,һԲ
u16 OS_TaskSuspend(u8 tasknum);	//
u16 OS_TaskResume(u8 tasknum);	//
//Ϊ,Ĺɾ
xTaskHandle xMainHandle;
#ifdef _TASK_1_
	xTaskHandle xTask1Handle;
#endif
#ifdef _TASK_2_
	xTaskHandle xTask2Handle;
#endif
#ifdef _TASK_3_
	xTaskHandle xTask3Handle;
#endif
#ifdef _TASK_4_
	xTaskHandle xTask4Handle;
#endif
#ifdef _TASK_5_
	xTaskHandle xTask5Handle;
#endif
#ifdef _TASK_6_
	xTaskHandle xTask6Handle;
#endif
#ifdef _TASK_7_
	xTaskHandle xTask7Handle;
#endif
#ifdef _TASK_8_
	xTaskHandle xTask8Handle;
#endif

void BoardHardware_Init(void)//RCUʼ
{
	E2RCU_Board_Init();//ʼRCUӲ
}
#define RTOS_TASK_STACK_SIZE	256//ջռ
#define RTOS_TASK_PRIORITIES	3//ûȼ
void Create_Task(void)//񴴽ϵͳ
{
	xTaskCreate(task_main_entry,//ַ,ָ
			        ( const signed char * )"task_main", //
			        RTOS_TASK_STACK_SIZE,//RTOS_TASK_STACK_SIZE,//256,//ջռ
			        NULL, //ָڲ򴴽
			        RTOS_TASK_PRIORITIES,//RTOS_TASK_PRIORITIES,//2//ȼ
			        &xMainHandle );//,ӦôӶ
#if _TASK_1_ > 0//ԤΪ1ʱ,ʼ֮ǰʼõ
	OS_TaskCreate(1);
#endif
#if _TASK_2_ > 0
	OS_TaskCreate(2);
#endif
#if _TASK_3_ > 0
	OS_TaskCreate(3);
#endif
#if _TASK_4_ > 0
	OS_TaskCreate(4);
#endif
#if _TASK_5_ > 0
	OS_TaskCreate(5);
#endif
#if _TASK_6_ > 0
	OS_TaskCreate(6);
#endif
#if _TASK_7_ > 0
	OS_TaskCreate(7);
#endif
#if _TASK_8_ > 0
	OS_TaskCreate(8);
#endif
	
	vTaskStartScheduler();//ʼ
}

void task_main_entry(void)//,붨
{
  main();
	vTaskDelete(NULL);//ֿⷵ
	return 0;
}
#ifdef _TASK_1_
void task1(void);
void task1_entry(void)
{
	task1();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_2_
void task2(void);
void task2_entry(void)
{
	task2();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_3_
void task3(void);
void task3_entry(void)
{
	task3();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_4_
void task4(void);
void task4_entry(void)
{
	task4();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_5_
void task5(void);
void task5_entry(void)
{
	task5();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_6_
void task6(void);
void task6_entry(void)
{
	task6();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_7_
void task7(void);
void task7_entry(void)
{
	task7();
	vTaskDelete(NULL);
}
#endif
#ifdef _TASK_8_
void task8(void);
void task8_entry(void)
{
	task8();
	vTaskDelete(NULL);
}
#endif

//ҪȡռõĶ˿ʹȨʱ,볬ʱȴʹȨ,ʱȻûлȡ,Ӧ˳Աִ
#define MUTEXTAKETICKTOWAIT		80//80ms
vu16 MutexTakeWaitTime=MUTEXTAKETICKTOWAIT;//˿ڱռµĳʱʱ
void SetPortMutexTakeWaitTime(u16 time){MutexTakeWaitTime=time;}
//modeΪ˿:0 ADC,1 IIC,2 IO(1Pin),3 IO 3PIN
//ȡRCU˿ʹȨ,ͬһ˿ͬʱֻܱ1ռ,
#define RcuWhichMutexTake(which,mode,Return) if(RcuPortMutexTake(which,mode)==2)\
                                             {\
																										 if(mode!=0)\
																										 {\
																											 u32 t_time=GetSystemTime()+MutexTakeWaitTime;\
																											 while(RcuPortMutexTake(which,mode)==2)\
																											 {\
																												 if(t_time<GetSystemTime())return(Return);\
																											 }\
																										 }\
																									 }
//ͷRCU˿ʹȨֻռж˿ڵʹȨʹøö˿																									 
#define RcuWhichMutexGive(which,mode,Return) RcuPortMutexGive(which,mode)

static vu8 _task_create_flag[16]={1,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
static vu8 _task_management_flag[16]={0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
#define vTaskHardwareMutexRelease(taskhandle) RcuPortMutexRelease(taskhandle)//ͷʹõ
#define vTaskManagement_Enter()								  os_setinterruptmask()//ںж
#define vTaskManagement_Leave()								  os_clearinterruptmask()//ںж
static u8 _Get_OSTaskNum(u8 tasknum)
{
	extern pxCurrentTCB;//ǰеջ
	if(tasknum)return tasknum;
	//if(pxCurrentTCB==xMainHandle)return 0;
#ifdef _TASK_1_
	if(pxCurrentTCB==xTask1Handle)return 1;
#endif
#ifdef _TASK_2_
	if(pxCurrentTCB==xTask2Handle)return 2;
#endif
#ifdef _TASK_3_
	if(pxCurrentTCB==xTask3Handle)return 3;
#endif
#ifdef _TASK_4_
	if(pxCurrentTCB==xTask4Handle)return 4;
#endif
#ifdef _TASK_5_
	if(pxCurrentTCB==xTask5Handle)return 5;
#endif
#ifdef _TASK_6_
	if(pxCurrentTCB==xTask6Handle)return 6;
#endif
#ifdef _TASK_7_
	if(pxCurrentTCB==xTask7Handle)return 7;
#endif
#ifdef _TASK_8_
	if(pxCurrentTCB==xTask8Handle)return 8;
#endif
	return 0;
}
static s16 RTOS_TaskManagement(xTaskHandle taskhandle,u8 mode)////ɾ
{
	switch(mode)
	{	//ɾ
		case 1:vTaskManagement_Enter();
			       vTaskHardwareMutexRelease(taskhandle);
			       vTaskDelete(taskhandle);
			       vTaskManagement_Leave();
	  return 1;
		//
		case 2:vTaskManagement_Enter();
			       vTaskHardwareMutexRelease(taskhandle);
		         vTaskSuspend(taskhandle);
		         vTaskManagement_Leave();
		return 2;
		break;
		//ѹ,ܻ
		case 3:vTaskResume(taskhandle);
		return 3;
		break;
	}
	return 0;
}
u16 OS_TaskManagement(u8 tasknum,u8 mode)//
{
	u16 state=NULL;
	extern pxCurrentTCB;//ǰеջ
	switch(tasknum)
	{
		case 0:///ɾԼ
		if(pxCurrentTCB!=xMainHandle)//Ҫ/ɾmain
		{
			state=RTOS_TaskManagement(NULL,mode);
		}
		break;
#ifdef _TASK_1_
		case 1:
			state=RTOS_TaskManagement(xTask1Handle, mode);
		break;
#endif
#ifdef _TASK_2_
		case 2:
			state=RTOS_TaskManagement(xTask2Handle, mode);
	  break;
#endif
#ifdef _TASK_3_
		case 3:
			state=RTOS_TaskManagement(xTask3Handle, mode);
		break;
#endif
#ifdef _TASK_4_
		case 4:
			state=RTOS_TaskManagement(xTask4Handle, mode);
    break;
#endif	
#ifdef _TASK_5_	
		case 5:
			state=RTOS_TaskManagement(xTask5Handle, mode);
    break;
#endif	
#ifdef _TASK_6_	
		case 6:
			state=RTOS_TaskManagement(xTask6Handle, mode);
    break;
#endif		
#ifdef _TASK_7_
		case 7:
			state=RTOS_TaskManagement(xTask7Handle, mode);
    break;
#endif
#ifdef _TASK_8_
		case 8:
			state=RTOS_TaskManagement(xTask8Handle, mode);
    break;
#endif		
	}
	return state;
}
u16 OS_TaskDelete(u8 tasknum)//ɾ
{
	u8 n=_Get_OSTaskNum(tasknum);//ȡ
	if(_task_create_flag[n]==0)return 0;//ûбֱӷ
	if(_task_management_flag[n]==1)return _task_management_flag[n];
	_task_management_flag[n]=1;
	OS_TaskManagement(tasknum, 1);
	return _task_management_flag[n];
}
u16 OS_TaskSuspend(u8 tasknum)//
{//ѾͲҪٽйѾɾܹ
	u8 n=_Get_OSTaskNum(tasknum);//ȡ
	if(_task_create_flag[n]==0)return 0;//ûбֱӷ
	if(_task_management_flag[n]==2||_task_management_flag[n]==1)return _task_management_flag[n];
	_task_management_flag[n]=2;
	OS_TaskManagement(tasknum, 2);
	return _task_management_flag[n];
}
u16 OS_TaskResume(u8 tasknum)//
{//ѾѵͲҪٽлѣѾɾܻ
	u8 n=_Get_OSTaskNum(tasknum);//ȡ
	if(_task_create_flag[n]==0)return 0;//ûбֱӷ
	if(_task_management_flag[n]==3||_task_management_flag[n]==1)return _task_management_flag[n];
	_task_management_flag[n]=3;
	OS_TaskManagement(tasknum, 3);
	return _task_management_flag[n];
}
u16 OS_TaskCreate(u8 tasknum)//
{
	if(_task_create_flag[tasknum])return 0;
	_task_management_flag[tasknum]=0;//־λ
	switch(tasknum)
	{
#ifdef _TASK_1_	
		case 1:
			xTaskCreate(task1_entry,//ַ,ָ
					        ( const signed char * )"task1", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask1Handle );//,ӦôӶ
		break;
#endif	//_TASK_1_	
#ifdef _TASK_2_
		case 2:
			xTaskCreate(task2_entry,//ַ,ָ
					        ( const signed char * )"task2", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask2Handle );//,ӦôӶ
	  break;
#endif //_TASK_2_
#ifdef _TASK_3_
		case 3:
			xTaskCreate(task3_entry,//ַ,ָ
					        ( const signed char * )"task3", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask3Handle );//,ӦôӶ
		break;
#endif //_TASK_3_
#ifdef _TASK_4_
		case 4:
			xTaskCreate(task4_entry,//ַ,ָ
					        ( const signed char * )"task4", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask4Handle );//,ӦôӶ
    break;
#endif	//_TASK_4_	
#ifdef _TASK_5_
		case 5:
			xTaskCreate(task5_entry,//ַ,ָ
					        ( const signed char * )"task5", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask5Handle );//,ӦôӶ
    break;
#endif	//_TASK_5_	
#ifdef _TASK_6_
		case 6:
			xTaskCreate(task6_entry,//ַ,ָ
					        ( const signed char * )"task6", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask6Handle );//,ӦôӶ
    break;
#endif	//_TASK_6_
#ifdef _TASK_7_	
		case 7:
			xTaskCreate(task7_entry,//ַ,ָ
					        ( const signed char * )"task7", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask7Handle );//,ӦôӶ
    break;
#endif	//_TASK_7_	
#ifdef _TASK_8_
		case 8:
			xTaskCreate(task8_entry,//ַ,ָ
					        ( const signed char * )"task8", //
					        RTOS_TASK_STACK_SIZE,//256,//ջռ
					        NULL, //ָڲ򴴽
					        RTOS_TASK_PRIORITIES,//2//ȼ
					        &xTask8Handle );//,ӦôӶ
    break;
#endif //_TASK_8_		
	}
	_task_create_flag[tasknum]=1;//񱻴,ظ
	return 1;
}

#endif//_JMDOS_H_
